VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'a small Button-Class (using multi-state-PNG-resources in conjunction with the PngCache-Class),
'which requires a Host-Form with Autoredraw=False for the Refreshs to work properly
Option Explicit

Event Click()

Public Enum PngButtonState
  PngBtnStateNormal
  PngBtnStateHovered
  PngBtnStatePressed
  PngBtnStateDisabled
End Enum

Private WithEvents Form As Form, MDown As Boolean
Attribute Form.VB_VarHelpID = -1
 
Public Key As String, State As PngButtonState, X As Long, Y As Long, dX As Long, dY As Long

Public Sub InitOn(HostForm As Form, Key As String, ByVal X As Long, ByVal Y As Long, Optional FileName As String)
  Set Form = HostForm
  If Len(FileName) Then PngCache.AddImage Key, FileName
  Me.Key = Key: Me.X = X: Me.Y = Y 'store the Init-Params in internal Vars
  dX = PngCache.Width(Key)
  dY = PngCache.Height(Key) \ PngCache.Height(Key) / dX
End Sub

Public Sub Render()
  PngCache.AlphaRenderTo Form.hDC, Key, X, Y, dX, dY, 0, dY * State
End Sub
 
Private Sub Form_Paint()
  Render
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  If Not HitTest(X, Y) Or State = PngBtnStateDisabled Then Exit Sub Else MDown = True
  State = PngBtnStatePressed
  Form.Refresh
End Sub
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  If State = PngBtnStateDisabled Then Exit Sub
  Dim NewState As PngButtonState
  If HitTest(X, Y) Then NewState = IIf(MDown, PngBtnStatePressed, PngBtnStateHovered)
  If State <> NewState Then State = NewState: Form.Refresh
End Sub
Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  MDown = False
  If State <> PngBtnStatePressed Then Exit Sub
  State = PngBtnStateNormal
  Form.Refresh
  RaiseEvent Click
End Sub

Private Function HitTest(ByVal MX As Single, ByVal MY As Single) As Boolean
  MX = Form.ScaleX(MX, Form.ScaleMode, vbPixels)
  MY = Form.ScaleX(MY, Form.ScaleMode, vbPixels)
  HitTest = MX > X And MX < (X + dX) And MY > Y And MY < (Y + dY)
End Function

