VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cPngCacheGDIP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit 'a GDI+ based Cache-Class for Png-Images (or -Sprites), later accessible per String-Key ... [Olaf Schmidt 2013]

Private Declare Sub MemCopy Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal CB&)
Private Declare Function CLSIDFromString& Lib "ole32" (ByVal lpsz As Any, pclsid As Any)
Private Declare Function OleCreatePictureIndirect& Lib "olepro32.dll" (PicDesc As Any, riid As Any, ByVal bPicOwnsHdl&, ppvObj As Any)

Private Declare Function CreateCompatibleDC& Lib "gdi32" (ByVal HDc&)
Private Declare Function SelectObject& Lib "gdi32" (ByVal HDc&, ByVal hObject&)
Private Declare Function DeleteDC& Lib "gdi32" (ByVal HDc&)
Private Declare Function CreateDIBSection& Lib "gdi32" (ByVal HDc&, pBitmapInfo As Any, ByVal un&, ppBits&, ByVal Hdl&, ByVal dw&)
Private Declare Function GdiAlphaBlend& Lib "gdi32" (ByVal HDc&, ByVal x&, ByVal y&, ByVal dX&, ByVal dY&, ByVal hdcSrc&, ByVal srcx&, ByVal srcy&, ByVal SrcdX&, ByVal SrcdY&, ByVal lBlendFunction&)

Private Type RECTL
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type
Private Type BitmapData
   Width As Long
   Height As Long
   stride As Long
   PixelFormat As Long
   scan0 As Long
   Reserved As Long
End Type
Private Declare Function GdiplusStartup Lib "gdiplus" (Token As Long, Inbuf As Long, Optional ByVal outputbuf As Long = 0) As Long
Private Declare Sub GdiplusShutdown Lib "gdiplus" (ByVal Token As Long)
Private Declare Function GdipLoadImageFromFile Lib "GdiPlus.dll" (ByVal pFilename As Long, ByRef pImage As Long) As Long
Private Declare Function GdipGetImageWidth Lib "gdiplus" (ByVal Image As Long, Width As Long) As Long
Private Declare Function GdipGetImageHeight Lib "gdiplus" (ByVal Image As Long, Height As Long) As Long
Private Declare Function GdipDisposeImage Lib "gdiplus" (ByVal Image As Long) As Long
Private Declare Function GdipBitmapLockBits Lib "gdiplus" (ByVal Bitmap As Long, Rct As RECTL, ByVal flags As Long, ByVal PixelFormat As Long, lockedBitmapData As BitmapData) As Long
Private Declare Function GdipBitmapUnlockBits Lib "gdiplus" (ByVal Bitmap As Long, lockedBitmapData As BitmapData) As Long
Private Declare Function GdipCreateHBITMAPFromBitmap Lib "gdiplus" (ByVal Bitmap As Long, hbmReturn As Long, ByVal background As Long) As Long

Private mToken As Long, mhDC As Long, OldBM As Long

Public Images As New Collection 'a Cache for StdPicture (IPicture/IPictureDisp)-Objects
 
Private Sub Class_Initialize()
Dim StartupInput(0 To 3) As Long: StartupInput(0) = 1
  GdiplusStartup mToken, StartupInput(0)
  mhDC = CreateCompatibleDC(0)
End Sub

Private Sub Class_Terminate()
  If mhDC Then DeleteDC mhDC
  GdiplusShutdown mToken
End Sub
 
Public Function AddImage(Key As String, FileName As String, Optional ImgWidth As Long, Optional ImgHeight As Long) As StdPicture
Dim Img As Long
  GdipLoadImageFromFile StrPtr(FileName), Img
    If Img Then Images.Add GetPictureFromGDIpImg(Img), Key Else Exit Function
    Set AddImage = GetPictureFromGDIpImg(Img, vbWhite)
  GdipDisposeImage Img
  
  ImgWidth = Width(Key): ImgHeight = Height(Key) 'fill the two ByRef-Params with the Pxl-Dimensions
End Function

Public Property Get Picture(Key As String) As StdPicture
  Set Picture = Images(Key)
End Property

Public Property Get Width(Key As String) As Long
  Width = Picture(Key).Width / Screen.TwipsPerPixelX * 0.566929133858268
End Property

Public Property Get Height(Key As String) As Long
  Height = Picture(Key).Height / Screen.TwipsPerPixelY * 0.566929133858268
End Property

Public Sub AlphaRenderTo(ByVal HDc As Long, Key As String, Optional ByVal x As Long, Optional ByVal y As Long, _
                                                           Optional ByVal dX As Long, Optional ByVal dY As Long, _
                                                           Optional ByVal XSrc As Long, Optional ByVal YSrc As Long, _
                                                           Optional ByVal GlobalAlpha As Double = 1)
  If dX = 0 Then dX = Width(Key)
  If dY = 0 Then dY = Height(Key)
 
  If Picture(Key).Handle Then OldBM = SelectObject(mhDC, Picture(Key).Handle)
  GdiAlphaBlend HDc, x, y, dX, dY, mhDC, XSrc, YSrc, dX, dY, 2 ^ 24 + &HFF0000 * GlobalAlpha
  If OldBM Then SelectObject mhDC, OldBM
End Sub

  
Private Function GetPictureFromGDIpImg(Img As Long, Optional ByVal BackColor As Long = -1) As StdPicture
Dim i As Long, hDIB As Long, Rct As RECTL, BMSrc As BitmapData, BI&(9), pDst As Long
Const PixelFormat32bppPARGB& = &HE200B

  If BackColor <> -1 Then 'if we are interested in just a "normal colored StdPic" (without AlphaChannel), then the following single Line is enough
    GdipCreateHBITMAPFromBitmap Img, hDIB, BackColor
  
  Else 'but this is "what you came for" (the extraction of the Premultiplied 32bit-Alpha-Data from the Png)
    GdipGetImageWidth Img, Rct.Right
    GdipGetImageHeight Img, Rct.Bottom
    GdipBitmapLockBits Img, Rct, 1, PixelFormat32bppPARGB, BMSrc
  
    If BMSrc.scan0 Then
      BI(0) = 40
      BI(1) = BMSrc.Width
      BI(2) = -BMSrc.Height
      BI(3) = 32 * 65536 + 1 '32bpp
      
      hDIB = CreateDIBSection(0, BI(0), 0, pDst, 0, 0) 'we create a DIB-section(Handle) with the approppriate 32bpp-size-allocation
      If hDIB Then 'if successful, then we copy over into pDst (and we keep in mind, that Stride can be longer than Width*4Bytes)
        For i = 0 To Rct.Bottom - 1
          MemCopy ByVal pDst + i * Rct.Right * 4, ByVal BMSrc.scan0 + i * Abs(BMSrc.stride), Rct.Right * 4
        Next i
      End If
      
      GdipBitmapUnlockBits Img, BMSrc
    End If
  End If
  
  If hDIB Then Set GetPictureFromGDIpImg = GetPictureFromHdl(hDIB)
End Function

Private Function GetPictureFromHdl(ByVal hBmp As Long) As StdPicture
Dim IID_IDispatch(0 To 3) As Long, PicDesc(0 To 4) As Long
  IID_IDispatch(0) = &H20400: IID_IDispatch(2) = &HC0: IID_IDispatch(3) = &H46000000

  PicDesc(0) = 20
  PicDesc(1) = vbPicTypeBitmap
  PicDesc(2) = hBmp

  OleCreatePictureIndirect PicDesc(0), IID_IDispatch(0), 1, GetPictureFromHdl
End Function

