VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cPngCacheWIA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit 'a WIA-based Cache-Class for Png-Images (or -Sprites), later accessible per String-Key ... [Olaf Schmidt 2013]

Private Declare Function CLSIDFromString& Lib "ole32" (ByVal lpsz As Any, pclsid As Any)
Private Declare Function CreateStreamOnHGlobal& Lib "ole32" (ByVal hGlobal&, ByVal fDeleteOnRelease&, ppstm As Any)
Private Declare Function OleLoadPicture& Lib "olepro32" (pStream As Any, ByVal lSize&, ByVal fRunmode&, riid As Any, ppvObj As Any)
Private Declare Function OleCreatePictureIndirect& Lib "olepro32.dll" (PicDesc As Any, riid As Any, ByVal bPicOwnsHdl&, ppvObj As Any)

Private Declare Function CreateCompatibleDC& Lib "gdi32" (ByVal HDc&)
Private Declare Function SelectObject& Lib "gdi32" (ByVal HDc&, ByVal hObject&)
Private Declare Function DeleteDC& Lib "gdi32" (ByVal HDc&)
Private Declare Function GdiAlphaBlend& Lib "gdi32" (ByVal HDc&, ByVal x&, ByVal y&, ByVal dX&, ByVal dY&, ByVal hdcSrc&, ByVal srcx&, ByVal srcy&, ByVal SrcdX&, ByVal SrcdY&, ByVal lBlendFunction&)
 
Private mhDC As Long, OldBM As Long
Public Images As New Collection 'a Cache for StdPicture (IPicture/IPictureDisp)-Objects
 
Private Sub Class_Initialize()
  mhDC = CreateCompatibleDC(0)
End Sub
Private Sub Class_Terminate()
  If mhDC Then DeleteDC mhDC
End Sub
 
Public Function AddImage(Key As String, FileName As String, Optional ImgWidth As Long, Optional ImgHeight As Long) As StdPicture
  With CreateObject("WIA.ImageFile")
    .LoadFile FileName
    ImgWidth = .Width: ImgHeight = .Height 'fill the two ByRef-Params with the Pxl-Dimensions
    Set AddImage = .FileData.Picture 'return a decoded version by default (this will always be a 24bpp-StdPicture without Alpha-Channel)

    Dim B() As Byte, i As Long, A As Double 'and here retrieve the Raw-Bytes ...
        B = .ARGBData.ImageFile(.Width, .Height).FileData.BinaryData 'in 32Bit BGRA-format...
        For i = 54 To IIf(.IsAlphaPixelFormat, UBound(B), 0) Step 4 'pre-multiply the B,G,R components
          If B(i + 3) < 255 Then: A = B(i + 3) / 255#: B(i) = B(i) * A: B(i + 1) = B(i + 1) * A: B(i + 2) = B(i + 2) * A
        Next i
    Images.Add LoadFromByteStream(B), Key '...and finally add those Bytes as a 32bpp-StdPicture into the Images-Col
  End With
End Function

Public Property Get Picture(Key As String) As StdPicture
  Set Picture = Images(Key)
End Property

Public Property Get Width(Key As String) As Long
  Width = Picture(Key).Width / Screen.TwipsPerPixelX * 0.566929133858268
End Property

Public Property Get Height(Key As String) As Long
  Height = Picture(Key).Height / Screen.TwipsPerPixelY * 0.566929133858268
End Property

Public Sub AlphaRenderTo(ByVal HDc As Long, Key As String, Optional ByVal x As Long, Optional ByVal y As Long, _
                                                           Optional ByVal dX As Long, Optional ByVal dY As Long, _
                                                           Optional ByVal XSrc As Long, Optional ByVal YSrc As Long, _
                                                           Optional ByVal GlobalAlpha As Double = 1)
  If dX = 0 Then dX = Width(Key)
  If dY = 0 Then dY = Height(Key)
 
  If Picture(Key).Handle Then OldBM = SelectObject(mhDC, Picture(Key).Handle)
  GdiAlphaBlend HDc, x, y, dX, dY, mhDC, XSrc, YSrc, dX, dY, 2 ^ 24 + &HFF0000 * GlobalAlpha
  If OldBM Then SelectObject mhDC, OldBM
End Sub

Private Function LoadFromByteStream(B() As Byte) As StdPicture
Static IPicture(0 To 15) As Byte
    If IPicture(0) = 0 Then CLSIDFromString StrPtr("{7BF80980-BF32-101A-8BBB-00AA00300CAB}"), IPicture(0)
 
Dim iStream As stdole.IUnknown
    If CreateStreamOnHGlobal(VarPtr(B(LBound(B))), 0, iStream) Then Exit Function
    OleLoadPicture ByVal ObjPtr(iStream), UBound(B) - LBound(B) + 1, 0, IPicture(0), LoadFromByteStream
End Function
